#!/usr/bin/ruby
#
#  Teleskop- und CCD-Berechung in Ruby
#
$autor   = "Panagiotis Xipteras"; # global variables begin with $
$sprache = "Ruby 1.8.7";
$zweck   = "Teleskop- und CCD-Berechung";
$webpage = "http:\/\/www.AstroDigital.net";
$garantie= "Fuer die Kalkulationen wird keine Haftung uebernommen.";
$version = "1.16 - Standard licence";
#
#======================================================================

#     #
#     #    ##    #####      #      ##    #####   #       ######  #    #
#     #   #  #   #    #     #     #  #   #    #  #       #       ##   #
#     #  #    #  #    #     #    #    #  #####   #       #####   # #  #
 #   #   ######  #####      #    ######  #    #  #       #       #  # #
  # #    #    #  #   #      #    #    #  #    #  #       #       #   ##
   #     #    #  #    #     #    #    #  #####   ######  ######  #    #

$vergr = 0 ;
$maxvergr = 0 ;
$oeffnungVerhaelt = 0 ;
$maxOkBrennweite = 0 ;
$minOkBrennweite = 0 ;
$trennRayleigh = 0 ;
$trennDawes = 0 ;
$minvergr = 0;
$linsen = 0;
$typbez = 0;
$limitMagnitude = 0;




#==============================================================================

#    #
#   #     ####   #    #   ####    #####    ##    #    #   #####  ######  #    #
#  #     #    #  ##   #  #          #     #  #   ##   #     #    #       ##   #
###      #    #  # #  #   ####      #    #    #  # #  #     #    #####   # #  #
#  #     #    #  #  # #       #     #    ######  #  # #     #    #       #  # #
#   #    #    #  #   ##  #    #     #    #    #  #   ##     #    #       #   ##
#    #    ####   #    #   ####      #    #    #  #    #     #    ######  #    #

#
#            SCHRITT 1 von 3:  HIER NUR EIN TELESKOP AUSWAEHLEN UND EINKOMMENTIEREN
#           -------------------+---------------+----------------------------------------------
#             Brennweite [mm]  | Oeffnung [mm] | "FLE" d.h. Reflektor (Newton,SC)
#                              |               | "FRA"      Achromat (Fraunhofen)
#                              |               | "SEMIAPO"  Semiapochromat (ED-Doublet)
#                              |               | "VOLLAPO"  Apochromat (FL-Doublet,ED-Triplet)
#           ===================+===============+==============================================
#
# ----------------------
# TAL - SIBERIA - GALAXY
# ----------------------
#
# $brennweite = 1200;  $oeffnung = 150; $typ ="FLE";  $modell="TAL-2M Newton (f/8)";
# $brennweite = 750;   $oeffnung = 150; $typ ="FLE";  $modell="TAL-150 Newton (f/5)";
#
# ----------------------
#      CELESTRON
# ----------------------
#
# $brennweite = 2800;  $oeffnung = 279; $typ ="FLE";  $modell="Celestron C11 (f/10)";
# $brennweite = 1764;  $oeffnung = 279; $typ ="FLE";  $modell="Celestron C11 (f/6.3)";
#
# ----------------------
#     PENTAX 
# ----------------------
#
$brennweite = 1000;   $oeffnung = 105;  $typ ="VOLLAPO"; $linsen=2;  $modell="Pentax 105SD (f/9.5)";
#
# ----------------------
#      TAKAHASHI
# ----------------------
#
# $brennweite = 568;   $oeffnung = 60;  $typ ="VOLLAPO"; $linsen=2;  $modell="Tak FS60C Refraktor with Extender-Q (f/9.6)";
# $brennweite = 355;   $oeffnung = 60;  $typ ="VOLLAPO"; $linsen=2;  $modell="Tak FS60C Refraktor (f/6)";
# $brennweite = 265;   $oeffnung = 60;  $typ ="VOLLAPO"; $linsen=2;  $modell="Tak FS60C Refraktor with Reducer (f/4.4)";
#
# $brennweite = 500;   $oeffnung = 90;  $typ ="SEMIAPO"; $linsen=2;  $modell="Tak Sky90 Refraktor";
#
# $brennweite = 630;   $oeffnung = 78;  $typ ="VOLLAPO"; $linsen=2;  $modell="Tak FS78  Refraktor (f/8)";
# $brennweite = 472;   $oeffnung = 78;  $typ ="VOLLAPO"; $linsen=2;  $modell="Tak FS78  Refraktor (f/6)";
#
# $brennweite = 530;  $oeffnung = 106; $typ ="VOLLAPO"; $linsen=4;  $modell="Tak FSQ106 Refraktor (f/5)";
#
# $brennweite = 1312;  $oeffnung = 102; $typ ="VOLLAPO"; $linsen=2;  $modell="Tak FS102 Refraktor (f/12.8)";
# $brennweite = 820;   $oeffnung = 102; $typ ="VOLLAPO"; $linsen=2;  $modell="Tak FS102 Refraktor (f/8)";
# $brennweite = 610;   $oeffnung = 102; $typ ="VOLLAPO"; $linsen=2;  $modell="Tak FS102 Refraktor (f/6)";
#
# $brennweite = 500;   $oeffnung = 180; $typ ="FLE";              $modell="Tak Epsilon 180ED (f/2.8)";
# $brennweite = 2415;   $oeffnung = 210; $typ ="FLE";              $modell="Tak Mewlon 210 (f/11.5)";
# $brennweite = 2170;   $oeffnung = 180; $typ ="FLE";              $modell="Tak Mewlon 180 (f/12)";
# $brennweite = 1250;   $oeffnung = 250; $typ ="FLE";              $modell="Tak BRC-250 (f/5)";
#
# $brennweite = 1000;  $oeffnung = 130;  $typ ="VOLLAPO"; $linsen=3;  $modell="Tak TOA-130 Refraktor (f/7.7)";
#
# ----------------------
#         VIXEN
# ----------------------
#
# $brennweite = 1200;   $oeffnung = 80;  $typ ="FRA";  $linsen=2; $modell="Vixen 80L Refraktor (f/15)";
#
# ----------------------
#         LIDL
# ----------------------
#
# $brennweite = 700;   $oeffnung = 70;  $typ ="FRA";  $linsen=2; $modell="LIDL 70mm Refraktor (f/10)";
#
# ----------------------
#      TESTOPTIK
# ----------------------
#
#$brennweite = 1270;  $oeffnung = 200;  $typ ="FLE"; $linsen=2;  $modell="TEST-SC8";



##
##    SCHRITT 2 von 3:  HIER NUR EINE CAMERA AUSWAEHLEN UND EINKOMMENTIEREN
##    =====================================================================
##
## ----------------------
##         MEADE
## ----------------------
##
## (1) Meade Deep Sky Imager - DSI
# $CCDmodell ="Meade DSI";
# $pixelSizeXMicrons = 9.6;  $chipSizeWidthInPixel  = 510;
# $pixelSizeYMicrons = 7.5;  $chipSizeHeightInPixel = 492;
##
## ----------------------
##         SBIG
## ----------------------
##
# (2) SBIG ST-7 XME
$CCDmodell ="SBIG ST-7 XME";
$pixelSizeXMicrons = 9;  $chipSizeWidthInPixel  = 765;
$pixelSizeYMicrons = 9;  $chipSizeHeightInPixel = 510;
##
## (3) SBIG ST-9 XE
#$CCDmodell ="SBIG ST-9 XE";
#$pixelSizeXMicrons = 20;  $chipSizeWidthInPixel  = 512;
#$pixelSizeYMicrons = 20;  $chipSizeHeightInPixel = 512;
##
# ----------------------
#       TEST CCD
# ----------------------
#
# (4) TEST-CCD
#$CCDmodell ="TEST-CCD 6.8 mu";
#$pixelSizeXMicrons = 6.8;  $chipSizeWidthInPixel  = 765;
#$pixelSizeYMicrons = 6.8;  $chipSizeHeightInPixel = 510;


##
##    SCHRITT 3 von 3: ABSPEICHERN UND AUF KOMMANDOZEILENEBENE EINGEBEN:
##                          perl teleskop.pl 
##    =====================================================================
##

#==============================================================================

#######
#        #    #  #    #  #    #   #####     #     ####   #    #  ######  #    #
#        #    #  ##   #  #   #      #       #    #    #  ##   #  #       ##   #
#####    #    #  # #  #  ####       #       #    #    #  # #  #  #####   # #  #
#        #    #  #  # #  #  #       #       #    #    #  #  # #  #       #  # #
#        #    #  #   ##  #   #      #       #    #    #  #   ##  #       #   ##
#         ####   #    #  #    #     #       #     ####   #    #  ######  #    #

# Methode mit Argumenten (call by value)

def wahrGesFeld(gFOku,brennwOku,brennwTel)
    
    vergr = brennwTel / brennwOku;
    wgf   = gFOku / vergr;
    return wgf;
end

#########################



def Oku(oeffnungTeleskop, gfoku, mm, brennweite, maxvergr, minvergr, bez)

    vergr = brennweite / mm ;
    austrittspupille = oeffnungTeleskop / vergr;

    printf("Mit %-15s| %2.0fmm (FOV=%2.0f), Vergroesserung=%3.0fx" , bez , mm , gfoku , vergr);
    
    if vergr > maxvergr
    	print " ist zu hoch!\n";
    elsif vergr < minvergr
    	print " ist zu niedrig!\n";
    else
    	printf(", wahres Gesichtsfeld=%3.2f",wahrGesFeld(gfoku, mm, brennweite));
	    printf(", Austrittspupille=%3.2f mm\n",austrittspupille);
    end
end


#########################

# _Lamda = 550nm => gelbes Licht

def lichtstaerke(_Lamda, _OeffnungTel, _BrennwTel);
    # Argumente: Landa[nm], OeffnungTel[cm], brennwTel[cm]
    
    # ls ist die Lichtstaerke von diesem Teleskop
    # lsFS102f8 ist die Lichtstaerke eine FS102 (820mm,f/8)
    # lsFS102f6 ist die Lichtstaerke eine FS102 (610mm,f/6)

    ls = ((_OeffnungTel/_Lamda.to_f)**2) * ((_OeffnungTel/_BrennwTel.to_f)**2) ;
    lsFS102f8 = ((102/_Lamda)**2) * ((102/820)**2);
    lsFS102f6 = ((102/_Lamda)**2) * ((102/610)**2);

    printf("Bei einer Lichtfrequenz von %3.0f nm\n",_Lamda);
    printf("hat dieses Teleskop eine Lichtstaerke von: %3.0f\n",ls*10E7);
    printf("Es ist %3.2f x lichtstaerker als ein Takahashi FS-102 (f/8)\n",ls/lsFS102f8);
    printf("und %3.2f x lichtstaerker als ein Takahashi FS-102 (f/6)\n",ls/lsFS102f6);

    return ls;
end



#########################



def showFOV(xachse, yachse)
    # Argumente: xachse[arcmin]  xachse[arcmin]
    
    xM51=8;  # Breite von M51 (Strudelgalaxie) in [arcmin]
    yM51=4;  # Laenge von M51 (Strudelgalaxie) in [arcmin]

    print "X => ist die FOV des Systems\n";
    print "o => ist die Flaechenbelegung von M51 auf dem CCD-Chip\n";
    print "\n";

    for y in 0..yachse
	  for x in 0..xachse
	    if ((x < xM51) && (y < yM51))
	      printf "o";
	    else
	      printf "X";
	    end
	  end
	  printf "\n";
    end
    return 0;
end

#==============================================================================

                         #####
                        #     #   ####   #####   ######
                        #        #    #  #    #  #
                        #        #    #  #    #  #####
                        #        #    #  #    #  #
                        #     #  #    #  #    #  #
                         #####    ####   #####   ######

# ===================
# TELESKOP Berechnung
# ===================
#
print "\n";

# mehrere Striche nebeneinander (eine Schleife in Ruby)
54.times do |x| ;  print "="; end; print "\n";


print "Zweck: " + $zweck + "\n";
print "Version: " + $version + "\n";
print "Autor: " + $autor + "\n";
print "Sprache: " + $sprache + "\n";
print "Webpage: " + $webpage + "\n";
print "Garantie: " + $garantie + "\n";

# mehrere Striche nebeneinander (eine Schleife in Ruby)
54.times do |x| ;  print "="; end; print "\n";


if $typ == "VOLLAPO"
    # 100x pro Zoll Oeffnung
    $maxvergr = (($oeffnung/10.0)/2.5) * 100.0 ;
    $typbez = "Vollapochromat";
    
elsif $typ == "SEMIAPO"
    # 3x die Oeffnung in cm
    $maxvergr = $oeffnung * 3;
    $typbez = "Semiapochromat";
    
elsif $typ == "FRA"
    # 2x die Oeffnung in cm
    $maxvergr = $oeffnung * 2;
    $typbez = "Achromat";
    
else  #  $typ == "FLE"
    # 1.5x die Oeffnung in cm
    $maxvergr = $oeffnung * 1.5 ;
    $typbez = "Reflektor";
end

$oeffnungVerhaelt = $brennweite/$oeffnung;
$maxOkBrennweite = $oeffnungVerhaelt * 7;
$minOkBrennweite = $brennweite/$maxvergr ;
$trennRayleigh = 13.8/($oeffnung/10);
$trennDawes = 11.7/($oeffnung/10);
$minvergr = $brennweite/$maxOkBrennweite;
$limitMagnitude = 8.8 + 5 * (Math.log($oeffnung/25)/Math.log(10)); # 25 means is 2.5 inches * 10


print "Modell = " + $modell + "\n";
print "Typ = " + $typbez + "\n";
print "Brennweite = " + $brennweite.to_s + "mm\n";
print "Oeffnung = " + $oeffnung.to_s + "mm\n";
printf("Oeffnungsverhaeltnis = f/%3.1f",$oeffnungVerhaelt.to_s);
print "\n";
printf("Trennung (Rayleigh)= %3.2f ''",$trennRayleigh.to_s);
print "\n";
printf("Trennung (Dawes)= %3.2f ''",$trennDawes);
print "\n";
printf("Visuelle Grenzgroesse= %3.2f mag",$limitMagnitude);
print "\n";

## mehrere Striche nebeneinander (eine Schleife in Ruby)
#54.times do |x| ;  print "="; end; print "\n";

printf("Abs.Min.Vergr. = %3.1f",$minvergr);
printf("x mit Ok = %3.1f",$maxOkBrennweite);
print "mm\n";

printf("Min. Vergr. (Trennung erhalten) =  %3.0f",$oeffnung/2);
printf("x mit Ok= %3.1f",$brennweite / ($oeffnung/2));
print "mm\n";

printf("Foerderliche Vergr. = %3.0f",$oeffnung);
printf("x mit Ok = %3.1f",$brennweite / $oeffnung);
print "mm\n";

printf("Sinnvolle MaxVergr = %3.0f",$maxvergr);
printf("x mit Ok = %3.1f",$brennweite / $maxvergr);
print "mm\n";

printf("Min.Okularbrennweite = %3.1f",$minOkBrennweite);
print  "mm\n";

printf("Max.Okularbrennweite = %3.1f",$maxOkBrennweite);
print  "mm\n";

printf("Lichtsammelvermoegen %3.0fx mehr als das menschliche Auge\n",($oeffnung * $oeffnung) / 49);
print  "\n\n";


# ==================
# Berechnung Okulare
# ==================
#
print "\nOKULAR Berechnung\n";
# 17 Striche nebeneinander
17.times do |x| ;  print "="; end; print "\n";

#
#  Oeffnung GF  mm Brennweite MinVergr MaxVergr Typ
#
Oku($oeffnung, 45, 40, $brennweite, $maxvergr, $minvergr, "Super Plossl");
Oku($oeffnung, 45, 30, $brennweite, $maxvergr, $minvergr, "Super Plossl");
Oku($oeffnung, 52, 25, $brennweite, $maxvergr, $minvergr, "Super Plossl");
Oku($oeffnung, 57, 25, $brennweite, $maxvergr, $minvergr, "Koenig");
Oku($oeffnung, 68, 20, $brennweite, $maxvergr, $minvergr, "TSW");
Oku($oeffnung, 52, 12, $brennweite, $maxvergr, $minvergr, "Takahashi LE");
Oku($oeffnung, 45, 10, $brennweite, $maxvergr, $minvergr, "Super Plossl");
Oku($oeffnung, 52, 7.5,$brennweite, $maxvergr, $minvergr, "Super Plossl");
Oku($oeffnung, 52, 5,  $brennweite, $maxvergr, $minvergr, "Takahashi LE");
Oku($oeffnung, 45, 4, $brennweite, $maxvergr, $minvergr, "Vixen LV");
Oku($oeffnung, 45, 2.8,  $brennweite, $maxvergr, $minvergr, "Takahashi LE");
Oku($oeffnung, 60, 3,  $brennweite, $maxvergr, $minvergr, "Televue Radian");

print "\n\n";



# =======================
# Berechnung Lichtstaerke
# =======================
#
print "\nLICHTSTAERKE Berechnung\n";
# 23 Striche nebeneinander
# mehrere Striche nebeneinander (eine Schleife in Ruby)
23.times do |x| ;  print "="; end; print "\n";
print "BRENNWEITE ==============>" + $brennweite.to_s + "\n";
print "OEFFNUNG ==============>" + $oeffnung.to_s + "\n";

lichtstaerke(550, $oeffnung, $brennweite); # in 550nm (yellow light)
print "\n\n";




# =======================
# Berechnungen CCD-Camera
# =======================
#
print "\nCCD Berechnung\n";
# 14 Striche nebeneinander
14.times do |x| ;  print "="; end; print "\n";

$pixelSizeAverageMicrons = ($pixelSizeXMicrons + $pixelSizeYMicrons) / 2 ;
$amountOfSkyPerPixel = (206.265 / $brennweite ) * $pixelSizeAverageMicrons ;
$amountOfSkyWidthPerPixel = (206.265 / $brennweite ) * $pixelSizeXMicrons ;
$amountOfSkyHeigthPerPixel = (206.265 / $brennweite ) * $pixelSizeYMicrons ;

$fieldOfViewWidthInArcSec  = $amountOfSkyWidthPerPixel * $chipSizeWidthInPixel;
$fieldOfViewHeigthInArcSec = $amountOfSkyHeigthPerPixel * $chipSizeHeightInPixel;

# Integer-Arithmetik ist notwendig ----------------

$fieldOfViewWidthInArcMin     = $fieldOfViewWidthInArcSec  / 60;
$fieldOfViewHeigthInArcMin    = $fieldOfViewHeigthInArcSec / 60;
$fieldOfViewWidthInArcMinSec  = $fieldOfViewWidthInArcSec  % 60;
$fieldOfViewHeigthInArcMinSec = $fieldOfViewHeigthInArcSec % 60;

print "Cameratyp: " + $CCDmodell + "\n";
print "Chipgroesse (BxH) [Pixel] = " + $chipSizeWidthInPixel.to_s + "x" + $chipSizeHeightInPixel.to_s + "\n";
print "Durchschittliche Pixelgroesse [Mikrometer] = " + $pixelSizeAverageMicrons.to_s + "\n";
printf("Firmamentflaeche pro Pixel [arcsec] = %3.2f\n",$amountOfSkyPerPixel);

#printf "Field of View in arc-seconds  = %3.2f x %3.2f\n", $fieldOfViewWidthInArcSec, $fieldOfViewHeigthInArcSec;
printf("Gesichtsfeld (FOV) [arcsec] x [arcsec] = %3.0f'%3.0f'' x %3.0f'%3.0f''\n",$fieldOfViewWidthInArcMin,$fieldOfViewWidthInArcMinSec,$fieldOfViewHeigthInArcMin, $fieldOfViewHeigthInArcMinSec);
print "\n\n";


# ==========================
# Visualisierung FOV der CCD
# ==========================
#
print "\nVisualisierung FOV der CCD\n";
# Striche nebeneinander
# mehrere Striche nebeneinander (eine Schleife in Ruby)
26.times do |x| ;  print "="; end; print "\n";

showFOV($fieldOfViewWidthInArcMin,$fieldOfViewHeigthInArcMin);


# Floating-Point-Arithmetik ab jetzt notwendig -------

print "\n\n";




# ===========
# Bemerkungen
# ===========
#
print "\nBEMERKUNGEN\n";
# 11 Striche nebeneinander
# mehrere Striche nebeneinander (eine Schleife in Ruby)
11.times do |x| ;  print "="; end; print "\n";

# ----------
# FARBFEHLER
# ----------

if  $typ == "FRA"	# Ein achromatischer Refraktor ?

    if $oeffnungVerhaelt < 15
     print "Bei Achromaten gibt es Farbfehler\n" ; 
    else
     print "Auch bei Achromaten KEIN Farbfehler\n" ;
    end
elsif  $typ == "SEMIAPO"	# Ein Semiapochromat ?
 
    if $oeffnungVerhaelt < 10
     print "Bei Semiapochromaten gibt es Farbfehler\n" ;
    else
     print "Auch bei Semiapochromaten KEIN Farbfehler\n" ;
    end
else
 
  print "keine\n";
end

# ------------------
# TRENNUNGSVERMOEGEN
# ------------------

if $trennRayleigh > 2.5
    print "Ungenuegende Separationsfaehigkeit. Die Trennung liegt bei ueber 2''.5 Bogensekunden. Geraet evtl. unbrauchbar.\n" ;


# ------------------------------
# ZUSAMMENSPIEL TELESKOP <-> CCD
# ------------------------------
#
#  Es muss $amountOfSkyPerPixel > $trennRayleigh
#
if $amountOfSkyPerPixel > $trennRayleigh
    print "TIPP: Sie koennen auch eine CCD mit kleineren Pixeln verwenden, um die Aufloesung der Fotos zu verbessern\n"; 

elsif (int($amountOfSkyPerPixel*100) == int($trennRayleigh*100))
    print "INFO: Die CCD-Pixel haben fuer dieses Teleskop die optimale Groesse\n";

else
    print "TIPP: Die CCD-Pixel koennten groesser sein, weil das Teleskop sie sowieso nicht ausreizen kann\n";
end

print "\n";



end

# PROGRAMMENDE
